/* 
 * Skycoin REST API.
 *
 * Skycoin is a next-generation cryptocurrency.
 *
 * The version of the OpenAPI document: 0.27.0
 * Contact: contact@skycoin.net
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Skyapi.Client.OpenAPIDateConverter;

namespace Skyapi.Model
{
    /// <summary>
    /// TransactionStatus
    /// </summary>
    [DataContract]
    public partial class TransactionStatus :  IEquatable<TransactionStatus>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="TransactionStatus" /> class.
        /// </summary>
        /// <param name="blockSeq">If confirmed, the sequence of the block in which the transaction was executed.</param>
        /// <param name="confirmed">confirmed.</param>
        /// <param name="height">If confirmed, how many blocks deep in the chain it is. Will be at least 1 if confirmed.</param>
        /// <param name="unconfirmed">unconfirmed.</param>
        public TransactionStatus(long? blockSeq = default(long?), bool? confirmed = default(bool?), long? height = default(long?), bool? unconfirmed = default(bool?))
        {
            this.BlockSeq = blockSeq;
            this.Confirmed = confirmed;
            this.Height = height;
            this.Unconfirmed = unconfirmed;
        }
        
        /// <summary>
        /// If confirmed, the sequence of the block in which the transaction was executed
        /// </summary>
        /// <value>If confirmed, the sequence of the block in which the transaction was executed</value>
        [DataMember(Name="block_seq", EmitDefaultValue=false)]
        public long? BlockSeq { get; set; }

        /// <summary>
        /// Gets or Sets Confirmed
        /// </summary>
        [DataMember(Name="confirmed", EmitDefaultValue=false)]
        public bool? Confirmed { get; set; }

        /// <summary>
        /// If confirmed, how many blocks deep in the chain it is. Will be at least 1 if confirmed
        /// </summary>
        /// <value>If confirmed, how many blocks deep in the chain it is. Will be at least 1 if confirmed</value>
        [DataMember(Name="height", EmitDefaultValue=false)]
        public long? Height { get; set; }

        /// <summary>
        /// Gets or Sets Unconfirmed
        /// </summary>
        [DataMember(Name="unconfirmed", EmitDefaultValue=false)]
        public bool? Unconfirmed { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class TransactionStatus {\n");
            sb.Append("  BlockSeq: ").Append(BlockSeq).Append("\n");
            sb.Append("  Confirmed: ").Append(Confirmed).Append("\n");
            sb.Append("  Height: ").Append(Height).Append("\n");
            sb.Append("  Unconfirmed: ").Append(Unconfirmed).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as TransactionStatus);
        }

        /// <summary>
        /// Returns true if TransactionStatus instances are equal
        /// </summary>
        /// <param name="input">Instance of TransactionStatus to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(TransactionStatus input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BlockSeq == input.BlockSeq ||
                    (this.BlockSeq != null &&
                    this.BlockSeq.Equals(input.BlockSeq))
                ) && 
                (
                    this.Confirmed == input.Confirmed ||
                    (this.Confirmed != null &&
                    this.Confirmed.Equals(input.Confirmed))
                ) && 
                (
                    this.Height == input.Height ||
                    (this.Height != null &&
                    this.Height.Equals(input.Height))
                ) && 
                (
                    this.Unconfirmed == input.Unconfirmed ||
                    (this.Unconfirmed != null &&
                    this.Unconfirmed.Equals(input.Unconfirmed))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BlockSeq != null)
                    hashCode = hashCode * 59 + this.BlockSeq.GetHashCode();
                if (this.Confirmed != null)
                    hashCode = hashCode * 59 + this.Confirmed.GetHashCode();
                if (this.Height != null)
                    hashCode = hashCode * 59 + this.Height.GetHashCode();
                if (this.Unconfirmed != null)
                    hashCode = hashCode * 59 + this.Unconfirmed.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
