/* 
 * Skycoin REST API.
 *
 * Skycoin is a next-generation cryptocurrency.
 *
 * The version of the OpenAPI document: 0.27.0
 * Contact: contact@skycoin.net
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Skyapi.Client.OpenAPIDateConverter;

namespace Skyapi.Model
{
    /// <summary>
    /// TransactionV2ParamsUnspent
    /// </summary>
    [DataContract]
    public partial class TransactionV2ParamsUnspent :  IEquatable<TransactionV2ParamsUnspent>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="TransactionV2ParamsUnspent" /> class.
        /// </summary>
        /// <param name="hoursSelection">hoursSelection.</param>
        /// <param name="unspents">unspents.</param>
        /// <param name="changeAddress">changeAddress.</param>
        /// <param name="to">to.</param>
        public TransactionV2ParamsUnspent(TransactionV2ParamsUnspentHoursSelection hoursSelection = default(TransactionV2ParamsUnspentHoursSelection), List<string> unspents = default(List<string>), string changeAddress = default(string), List<TransactionV2ParamsUnspentTo> to = default(List<TransactionV2ParamsUnspentTo>))
        {
            this.HoursSelection = hoursSelection;
            this.Unspents = unspents;
            this.ChangeAddress = changeAddress;
            this.To = to;
        }
        
        /// <summary>
        /// Gets or Sets HoursSelection
        /// </summary>
        [DataMember(Name="hours_selection", EmitDefaultValue=false)]
        public TransactionV2ParamsUnspentHoursSelection HoursSelection { get; set; }

        /// <summary>
        /// Gets or Sets Unspents
        /// </summary>
        [DataMember(Name="unspents", EmitDefaultValue=false)]
        public List<string> Unspents { get; set; }

        /// <summary>
        /// Gets or Sets ChangeAddress
        /// </summary>
        [DataMember(Name="change_address", EmitDefaultValue=false)]
        public string ChangeAddress { get; set; }

        /// <summary>
        /// Gets or Sets To
        /// </summary>
        [DataMember(Name="to", EmitDefaultValue=false)]
        public List<TransactionV2ParamsUnspentTo> To { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class TransactionV2ParamsUnspent {\n");
            sb.Append("  HoursSelection: ").Append(HoursSelection).Append("\n");
            sb.Append("  Unspents: ").Append(Unspents).Append("\n");
            sb.Append("  ChangeAddress: ").Append(ChangeAddress).Append("\n");
            sb.Append("  To: ").Append(To).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as TransactionV2ParamsUnspent);
        }

        /// <summary>
        /// Returns true if TransactionV2ParamsUnspent instances are equal
        /// </summary>
        /// <param name="input">Instance of TransactionV2ParamsUnspent to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(TransactionV2ParamsUnspent input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.HoursSelection == input.HoursSelection ||
                    (this.HoursSelection != null &&
                    this.HoursSelection.Equals(input.HoursSelection))
                ) && 
                (
                    this.Unspents == input.Unspents ||
                    this.Unspents != null &&
                    input.Unspents != null &&
                    this.Unspents.SequenceEqual(input.Unspents)
                ) && 
                (
                    this.ChangeAddress == input.ChangeAddress ||
                    (this.ChangeAddress != null &&
                    this.ChangeAddress.Equals(input.ChangeAddress))
                ) && 
                (
                    this.To == input.To ||
                    this.To != null &&
                    input.To != null &&
                    this.To.SequenceEqual(input.To)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.HoursSelection != null)
                    hashCode = hashCode * 59 + this.HoursSelection.GetHashCode();
                if (this.Unspents != null)
                    hashCode = hashCode * 59 + this.Unspents.GetHashCode();
                if (this.ChangeAddress != null)
                    hashCode = hashCode * 59 + this.ChangeAddress.GetHashCode();
                if (this.To != null)
                    hashCode = hashCode * 59 + this.To.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
