/* 
 * Skycoin REST API.
 *
 * Skycoin is a next-generation cryptocurrency.
 *
 * The version of the OpenAPI document: 0.27.0
 * Contact: contact@skycoin.net
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Skyapi.Client.OpenAPIDateConverter;

namespace Skyapi.Model
{
    /// <summary>
    /// TransactionVerifyRequest
    /// </summary>
    [DataContract]
    public partial class TransactionVerifyRequest :  IEquatable<TransactionVerifyRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="TransactionVerifyRequest" /> class.
        /// </summary>
        /// <param name="unsigned">unsigned.</param>
        /// <param name="encodedTransaction">encodedTransaction.</param>
        public TransactionVerifyRequest(bool? unsigned = default(bool?), string encodedTransaction = default(string))
        {
            this.Unsigned = unsigned;
            this.EncodedTransaction = encodedTransaction;
        }
        
        /// <summary>
        /// Gets or Sets Unsigned
        /// </summary>
        [DataMember(Name="unsigned", EmitDefaultValue=false)]
        public bool? Unsigned { get; set; }

        /// <summary>
        /// Gets or Sets EncodedTransaction
        /// </summary>
        [DataMember(Name="encoded_transaction", EmitDefaultValue=false)]
        public string EncodedTransaction { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class TransactionVerifyRequest {\n");
            sb.Append("  Unsigned: ").Append(Unsigned).Append("\n");
            sb.Append("  EncodedTransaction: ").Append(EncodedTransaction).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as TransactionVerifyRequest);
        }

        /// <summary>
        /// Returns true if TransactionVerifyRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of TransactionVerifyRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(TransactionVerifyRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Unsigned == input.Unsigned ||
                    (this.Unsigned != null &&
                    this.Unsigned.Equals(input.Unsigned))
                ) && 
                (
                    this.EncodedTransaction == input.EncodedTransaction ||
                    (this.EncodedTransaction != null &&
                    this.EncodedTransaction.Equals(input.EncodedTransaction))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Unsigned != null)
                    hashCode = hashCode * 59 + this.Unsigned.GetHashCode();
                if (this.EncodedTransaction != null)
                    hashCode = hashCode * 59 + this.EncodedTransaction.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
